GEOS: geos::geom::prep::BasicPreparedGeometry Class Reference

Public Member Functions | Protected Member Functions

# geos::geom::prep::BasicPreparedGeometry Class Reference

A base class for PreparedGeometry subclasses. More...

`#include <BasicPreparedGeometry.h>`

Inheritance diagram for geos::geom::prep::BasicPreparedGeometry:

List of all members.

## Public Member Functions
| BasicPreparedGeometry (const Geometry *geom)
const geom::Geometry & | getGeometry () const
const Coordinate::ConstVect * | getRepresentativePoints () const
bool | isAnyTargetComponentInTest (const geom::Geometry *testGeom) const
bool | contains (const geom::Geometry *g) const
bool | containsProperly (const geom::Geometry *g) const
bool | coveredBy (const geom::Geometry *g) const
bool | covers (const geom::Geometry *g) const
bool | crosses (const geom::Geometry *g) const
bool | disjoint (const geom::Geometry *g) const
bool | intersects (const geom::Geometry *g) const
bool | overlaps (const geom::Geometry *g) const
bool | touches (const geom::Geometry *g) const
bool | within (const geom::Geometry *g) const
std::string | toString ()
## Protected Member Functions
void | setGeometry (const geom::Geometry *geom)
bool | envelopesIntersect (const geom::Geometry *g) const
bool | envelopeCovers (const geom::Geometry *g) const

## Detailed Description

A base class for PreparedGeometry subclasses.

Contains default implementations for methods, which simply delegate to the equivalent Geometry methods. This class may be used as a "no-op" class for Geometry types which do not have a corresponding PreparedGeometry implementation.

Author:
  Martin Davis

## Member Function Documentation

bool geos::geom::prep::BasicPreparedGeometry::contains | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

Reimplemented in geos::geom::prep::PreparedPolygon.

bool geos::geom::prep::BasicPreparedGeometry::containsProperly | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

Reimplemented in geos::geom::prep::PreparedPolygon.

bool geos::geom::prep::BasicPreparedGeometry::coveredBy | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

bool geos::geom::prep::BasicPreparedGeometry::covers | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

Reimplemented in geos::geom::prep::PreparedPolygon.

bool geos::geom::prep::BasicPreparedGeometry::crosses | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

bool geos::geom::prep::BasicPreparedGeometry::disjoint | ( | const geom::Geometry * | g ) | const`[virtual]`

Standard implementation for all geometries. Supports GeometryCollections as input.

Implements geos::geom::prep::PreparedGeometry.

bool geos::geom::prep::BasicPreparedGeometry::envelopeCovers | ( | const geom::Geometry * | g ) | const`[protected]`

Determines whether the envelope of this geometry covers the Geometry g.

Parameters:

  g | a Geometry

Returns:
  true if g is contained in this envelope

bool geos::geom::prep::BasicPreparedGeometry::envelopesIntersect | ( | const geom::Geometry * | g ) | const`[protected]`

Determines whether a Geometry g interacts with this geometry by testing the geometry envelopes.

Parameters:

  g | a Geometry

Returns:
  true if the envelopes intersect

const geom::Geometry& geos::geom::prep::BasicPreparedGeometry::getGeometry | ( | ) | const`[inline, virtual]`

Gets the original Geometry which has been prepared.

Returns:
  the base geometry

Implements geos::geom::prep::PreparedGeometry.

const Coordinate::ConstVect* geos::geom::prep::BasicPreparedGeometry::getRepresentativePoints | ( | ) | const`[inline]`

Gets the list of representative points for this geometry. One vertex is included for every component of the geometry (i.e. including one for every ring of polygonal geometries)

Returns:
  a List of Coordinate

bool geos::geom::prep::BasicPreparedGeometry::intersects | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

Reimplemented in geos::geom::prep::PreparedLineString, and geos::geom::prep::PreparedPolygon.

bool geos::geom::prep::BasicPreparedGeometry::isAnyTargetComponentInTest | ( | const geom::Geometry * | testGeom ) | const

Tests whether any representative of the target geometry intersects the test geometry. This is useful in A/A, A/L, A/P, L/P, and P/P cases.

Parameters:

  geom | the test geometry
  repPts | the representative points of the target geometry

Returns:
  true if any component intersects the areal test geometry

bool geos::geom::prep::BasicPreparedGeometry::overlaps | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

void geos::geom::prep::BasicPreparedGeometry::setGeometry | ( | const geom::Geometry * | geom ) | `[protected]`

Sets the original Geometry which will be prepared.

bool geos::geom::prep::BasicPreparedGeometry::touches | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

bool geos::geom::prep::BasicPreparedGeometry::within | ( | const geom::Geometry * | g ) | const`[virtual]`

Default implementation.

Implements geos::geom::prep::PreparedGeometry.

The documentation for this class was generated from the following file:

- BasicPreparedGeometry.h